//UhrzeitEinfuegen_501d.js
// 22.02.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Ergnzt Beschriftungen mit der Uhrzeit

/*
Mein Dank geht an zwei Mitglieder des Forums "HilfDirSelbst":
 "mac_heibu": ist der Initiant dieses Scripts
 "drerol74":  lieferte eine vielseitigere Methode zum Finden der Bilder
*/

withSeconds = true; // die Uhrzeit mit Sekunden
//withSeconds = false; // die Uhrzeit ohne Sekunden

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument offen ist
if (app.documents.length == 0) {
	alert ("Es ist *kein* Dokument offen.", "Achtung");
	exit();
}

// das vorderste Dokument
var curDoc = app.activeDocument;

// die GREP-Vorgaben zum Finden des Datum-Strings vorbereiten
app.findGrepPreferences = app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{2,4}$";

// ein RegExp zum Ausziehen der Uhrzeit definieren
var objRegExp = new RegExp("([0-9]{2}:[0-9]{2}:[0-9]{2})");

// die temporre Textvariable initialisieren
varName = app.activeDocument.textVariables.itemByName("Bildname");

// die Auswahl speichern und prfen
var curSel = app.selection;
var delSel = false;
if (curSel.length == 0) {
	var oneSpread = false;
	for (var s=0; s<curDoc.spreads.length; s++) {
		getObjects(oneSpread, s);
		insTime();
	}
}
else {
	var nItems = curSel.length;
	txtFramesList = new Array ();
	for (var i=0; i<nItems; i++) {
		curItem = curSel[i];
		if (curItem.constructor.name == "TextFrame") {
			txtFramesList.push(curItem);
		}
		else if (curItem.hasOwnProperty("baseline")) {
			txtFramesList.push(curItem.parent.textContainers[0]);
			delSel = true;
		}
		else if (curItem.constructor.name == "Group") {
			getGroupItems(curItem);
		}
	}
	if (txtFramesList.length == 0) {
		alert ("Es ist kein *Textrahmen* ausgewhlt.", "Achtung");
		exit();
	}
	var actSpread = txtFramesList[0].parent;
	if (actSpread.constructor.name != "Spread") {
		actSpread = actSpread.parent;
	}
	if (actSpread.constructor.name != "Spread") {
		actSpread = app.activeWindow.activeSpread;
	}
	var oneSpread = true;
	var s = actSpread.index;
	getObjects(oneSpread, s);
	insTime();
}

// die GREP-Vorgaben zurcksetzen
app.findGrepPreferences = app.changeGrepPreferences = null;

// die Auswahl aufheben (falls notwendig)
if (delSel) {
	app.selection = null;
}

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();


// die Funktionen /////////////////////////////////////////////////////////////////////////////////

// die Textrahmen in Gruppen aufspren
function getGroupItems(curItem) {
	var allObjects = curItem.allPageItems;
	for (var n=0; n<allObjects.length; n++) {
		grpItem = allObjects[n];
		if (grpItem.constructor.name == "TextFrame") {
			txtFramesList.push(grpItem);
		}
		else if (grpItem.constructor.name == "Group") {
			getGroupItems(grpItem);
		}
	}
}

// die Objekte des aktuellen Druckbogens auflisten
function getObjects(oneSpread, s) {
	var allObjects = curDoc.spreads[s].allPageItems;
	if (oneSpread == false) {
		txtFramesList = new Array ();
		for (var n=0; n<allObjects.length; n++) {
			var curObject = allObjects[n];
			if (curObject instanceof TextFrame) {
				txtFramesList.push(curObject);
			}
		}
	}
	itemLinkList = new Array ();
	for (var n=0; n<allObjects.length; n++) {
		var curObject = allObjects[n];
		if (curObject instanceof Rectangle ||curObject instanceof Polygon ||curObject instanceof Oval) {
			try {
				itemLinkList.push(curObject.graphics[0].itemLink);
			}
			catch (e) {
			}
		}
	}
}

// Bildname feststellen, die Uhrzeit ausziehen und einsetzen
function insTime() {
	// Inhalt prfen (Datum am Ende des Absatzes
	for (var f=0; f<txtFramesList.length; f++) {
		var okay = "";
		try {
			okay = txtFramesList[f].findGrep();
		}
		catch (e) {
		}
		// wenn der Rahmeninhalt mit einem Datum endet ...
		if (okay.length == 1) {
			// eine temporre Textvariable einfgen 
			var textVarInstance = txtFramesList[f].parentStory.insertionPoints[-1].textVariableInstances.add();
			textVarInstance.associatedTextVariable = varName;
			// den Bildnamen ausziehen
			imgName = textVarInstance.resultText.replace("[<>]","","g");
			// die Textvariavble wieder entfernen
			textVarInstance.remove();
			var timeStr = "";
			// eine Schleife durch den 'ItemLink'-Array
			for (var n=0; n<itemLinkList.length; n++) {
				curLink = itemLinkList[n];
				curName = curLink.name;
				if (curName == imgName) {
					try {
						curDate = "" + curLink.linkXmp.creationDate; // XMP-Erzeugungs-Datum
						// die Uhrzeit ausziehen, nach Wunsch mit oder ohne Sekunden 
						if (withSeconds) {
							timeStr = curDate.match(objRegExp)[1];
						}
						else {
							timeStr = curDate.match(objRegExp)[1].slice(0,-3);
						}
						break;
					}
					catch (e) {
					}
				}
			}
			// wenn der Zeitstring nicht leer ist, versuchen ihn einzusetzen
			if (timeStr != "") {
				try {
					txtFramesList[f].parentStory.insertionPoints[-1].contents = ", " + timeStr + " Uhr";
				}
				catch (e) {
				}
			}
		}
	}
}